<template>
    <v-row justify="center">
        <v-dialog max-width="600px" v-model="dialog">
            <template v-slot:activator="{ on, attrs }">
                <v-btn fab outlined x-small v-bind="attrs" v-on="on"><v-icon>mdi-pencil</v-icon> </v-btn>
            </template>
            <v-card>
                <v-card-title>{{ dia }} </v-card-title>
                <v-card-text>
                    <v-container>
                        <v-row>
                            <v-col cols="12" md="6" sm="4">
                                Hora de apertura
                            </v-col>

                            <v-col cols="12" md="6" sm="4">
                                <v-menu
                                    ref="initHour"
                                    v-model="menu2"
                                    :close-on-content-click="false"
                                    :return-value.sync="initEditHour"
                                    transition="scale-transition"
                                    offset-y
                                    max-width="290px"
                                    min-width="290px"
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-text-field
                                            :rules="[v => !!v || 'Campo requerido']"
                                            label="Hora de apertura"
                                            class="txt2"
                                            type="text"
                                            v-model="initEditHour"
                                            v-bind="attrs"
                                            v-on="on"
                                        ></v-text-field>
                                    </template>
                                    <v-time-picker
                                        v-if="menu2"
                                        v-model="initEditHour"
                                        full-width
                                        format="ampm"
                                        type="time"
                                        min="9:00"
                                        no-title
                                    >
                                        <slot name="defaut">
                                            <span>BeeMenu empieza a repartir a las 9 AM</span>
                                            <v-btn color="primary" @click="$refs.initHour.save(initEditHour)"
                                                >Guardar</v-btn
                                            >
                                        </slot>
                                    </v-time-picker>
                                </v-menu>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col cols="12" md="6" sm="4">
                                Hora de cierre
                            </v-col>
                            <v-col cols="12" md="6" sm="4">
                                <v-menu
                                    ref="endHour"
                                    v-model="menu1"
                                    :close-on-content-click="false"
                                    :nudge-right="40"
                                    :return-value.sync="endEditHour"
                                    transition="scale-transition"
                                    offset-y
                                    max-width="290px"
                                    min-width="290px"
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-text-field
                                            :rules="[v => !!v || 'Campo requerido']"
                                            label="Hora de cierre"
                                            class="txt2"
                                            type="text"
                                            v-model="endEditHour"
                                            v-bind="attrs"
                                            v-on="on"
                                        ></v-text-field>
                                    </template>
                                    <v-time-picker
                                        v-if="menu1"
                                        v-model="endEditHour"
                                        full-width
                                        format="ampm"
                                        max="22:00"
                                        no-title
                                    >
                                        <slot name="defaut">
                                            <span>BeeMenu deja de repartir a las 10 PM</span>
                                            <v-btn color="primary" @click="$refs.endHour.save(endEditHour)"
                                                >Guardar</v-btn
                                            >
                                        </slot></v-time-picker
                                    >
                                </v-menu>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col cols="12" md="6" sm="4">
                                Dia laboral
                            </v-col>

                            <v-col cols="12" md="6" sm="4">
                                <v-switch v-model="isOpen" inset label="Cerrado/Abierto"></v-switch>
                            </v-col>
                        </v-row>

                        <v-dialog v-model="message.show" rounded="" max-width="290">
                            <v-alert
                                style="text-align:center; margin:0;"
                                justify="center"
                                v-model="message.show"
                                dismissible
                                :type="message.type"
                                >{{ message.message }}</v-alert
                            >
                        </v-dialog>
                    </v-container>
                </v-card-text>
                <v-divider></v-divider>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="#fdb947" text @click="close">Cancelar</v-btn>
                    <v-btn color="#fdb947" rounded class="mr-4" @click="updateMenuDelivery()">Guardar</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>
<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { DeliveryService } from '@/services/DeliveryService';
import { DaysOfWeek, DEFAULT_SCHEDULE, Schedule } from '@/model/delivery/Schedule';
import { DeliveryMenu } from '@/model/delivery/DeliveryMenu';
import { DEFAULT_COST_SHIPPING } from '@/model/delivery/CostShipping';
import { DEFAULT_PAYMENT } from '@/model/delivery/Payment';
import { DEFAULT_PHONES } from '@/model/delivery/Phones';
import { DEFAULT_LOCATION } from '@/model/delivery/Location';

@Component
export default class ScheduledaysDialog extends Vue {
    private readonly deliveryService = new DeliveryService();
    @Prop()
    dia!: DaysOfWeek;

    delivery: DeliveryMenu = new DeliveryMenu(
        '',
        '',
        DEFAULT_COST_SHIPPING,
        '',
        DEFAULT_PAYMENT,
        DEFAULT_PHONES,
        '',
        DEFAULT_SCHEDULE,
        '',
        false,
        false,
        '',
        DEFAULT_LOCATION,
        false,
        false
    );

    dialog = false;
    initEditHour = '';
    endEditHour = '';
    menu1 = false;
    modal1 = false;
    isOpen = false;
    menu2 = false;
    modal2 = false;

    initSchedule = new Date();
    endSchedule = new Date();
    message: { message: string; type: 'success' | 'info' | 'warning' | 'error'; show: boolean } = {
        message: '',
        type: 'error',
        show: false
    };

    async updateMenuDelivery() {
        const schedueleUpdate = this.getCopySchedule();
        const initDate = new Date('1970-01-01T' + this.initEditHour);
        const endDate = new Date('1970-01-01T' + this.endEditHour);

        schedueleUpdate[this.dia].initHour = initDate;
        schedueleUpdate[this.dia].endHour = endDate;
        schedueleUpdate[this.dia].initDay = this.dia;
        schedueleUpdate[this.dia].endDay = initDate > endDate ? this.getDayAfter(this.dia) : this.dia;
        schedueleUpdate[this.dia].open = this.isOpen;

        await this.deliveryService.updateDeliverySchedule(this.delivery.id, schedueleUpdate);
        this.message = { message: 'MENÚ DELIVERY ACTUALIZADO', type: 'success', show: true };
        this.initScheduleFromStore();
        this.dialog = false;
    }

    getDayAfter(day: DaysOfWeek): DaysOfWeek {
        switch (day) {
            case DaysOfWeek.DOMINGO:
                return DaysOfWeek.LUNES;
            case DaysOfWeek.LUNES:
                return DaysOfWeek.MARTES;
            case DaysOfWeek.MARTES:
                return DaysOfWeek.MIERCOLES;
            case DaysOfWeek.MIERCOLES:
                return DaysOfWeek.JUEVES;
            case DaysOfWeek.JUEVES:
                return DaysOfWeek.VIERNES;
            case DaysOfWeek.VIERNES:
                return DaysOfWeek.SABADO;
            case DaysOfWeek.SABADO:
                return DaysOfWeek.DOMINGO;
            default:
                return day;
        }
    }

    getCopySchedule(): Schedule {
        const copy = JSON.parse(JSON.stringify(this.$store.state.DeliveryModule.delivery.schedule));
        for (const day in copy) {
            const dayAux = day as DaysOfWeek;
            const daySchedule = copy[dayAux];
            copy[dayAux].initHour = new Date(daySchedule.initHour);
            copy[dayAux].endHour = new Date(daySchedule.endHour);
        }
        return copy;
    }

    setMessage(message: string, type: 'success' | 'info' | 'warning' | 'error') {
        this.message = { message, type, show: true };
    }

    close() {
        this.dialog = false;
        this.initScheduleFromStore();
    }

    initScheduleFromStore() {
        this.delivery = this.$store.state.DeliveryModule.delivery;
        this.initSchedule = this.delivery.schedule[this.dia].initHour;
        this.endSchedule = this.delivery.schedule[this.dia].endHour;
        this.initEditHour = this.initSchedule.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' });
        this.endEditHour = this.endSchedule.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' });
        this.isOpen = this.delivery.schedule[this.dia].open;
    }

    created() {
        this.initScheduleFromStore();
    }
}
</script>

<style scoped></style>
